// David Denny, 1001915603

// 11-bit Right Barrel Shifter
module ElevenBitRightShifter
	(
		input  [10:0] in,
		input  [3:0]  ctrl,
		output [10:0] out
	);
	
	// Internal Wires Used For Shifter
	wire   [10:0] x, y, z;
	 
	 // 8-bit shift right
    mux2x1 ins_1  (.in0(in[10]), .in1(1'b0),   .sel(ctrl[3]), .out(x[10]));
    mux2x1 ins_2  (.in0(in[9]),  .in1(1'b0),   .sel(ctrl[3]), .out(x[9]));
    mux2x1 ins_3  (.in0(in[8]),  .in1(1'b0),   .sel(ctrl[3]), .out(x[8]));
    mux2x1 ins_4  (.in0(in[7]),  .in1(1'b0),   .sel(ctrl[3]), .out(x[7]));
    mux2x1 ins_5  (.in0(in[6]),  .in1(1'b0),   .sel(ctrl[3]), .out(x[6]));
    mux2x1 ins_6  (.in0(in[5]),  .in1(1'b0),   .sel(ctrl[3]), .out(x[5]));
    mux2x1 ins_7  (.in0(in[4]),  .in1(1'b0),   .sel(ctrl[3]), .out(x[4]));
    mux2x1 ins_8  (.in0(in[3]),  .in1(1'b0),   .sel(ctrl[3]), .out(x[3]));
    mux2x1 ins_9  (.in0(in[2]),  .in1(in[10]), .sel(ctrl[3]), .out(x[2]));
    mux2x1 ins_10 (.in0(in[1]),  .in1(in[9]),  .sel(ctrl[3]), .out(x[1]));
    mux2x1 ins_11 (.in0(in[0]),  .in1(in[8]),  .sel(ctrl[3]), .out(x[0]));

    // 4-bit shift right
    mux2x1 ins_107 (.in0(x[10]), .in1(1'b0),  .sel(ctrl[2]), .out(y[10]));
    mux2x1 ins_106 (.in0(x[9]),  .in1(1'b0),  .sel(ctrl[2]), .out(y[9]));
    mux2x1 ins_105 (.in0(x[8]),  .in1(1'b0),  .sel(ctrl[2]), .out(y[8]));
    mux2x1 ins_104 (.in0(x[7]),  .in1(1'b0),  .sel(ctrl[2]), .out(y[7]));
    mux2x1 ins_103 (.in0(x[6]),  .in1(x[10]), .sel(ctrl[2]), .out(y[6]));
    mux2x1 ins_102 (.in0(x[5]),  .in1(x[9]),  .sel(ctrl[2]), .out(y[5]));
    mux2x1 ins_101 (.in0(x[4]),  .in1(x[8]),  .sel(ctrl[2]), .out(y[4]));
    mux2x1 ins_100 (.in0(x[3]),  .in1(x[7]),  .sel(ctrl[2]), .out(y[3]));
    mux2x1 ins_99  (.in0(x[2]),  .in1(x[6]),  .sel(ctrl[2]), .out(y[2]));
    mux2x1 ins_98  (.in0(x[1]),  .in1(x[5]),  .sel(ctrl[2]), .out(y[1]));
    mux2x1 ins_97  (.in0(x[0]),  .in1(x[4]),  .sel(ctrl[2]), .out(y[0]));

    // 2-bit shift right
    mux2x1 ins_207 (.in0(y[10]), .in1(1'b0),  .sel(ctrl[1]), .out(z[10]));
    mux2x1 ins_206 (.in0(y[9]),  .in1(1'b0),  .sel(ctrl[1]), .out(z[9]));
    mux2x1 ins_205 (.in0(y[8]),  .in1(y[10]), .sel(ctrl[1]), .out(z[8]));
    mux2x1 ins_204 (.in0(y[7]),  .in1(y[9]),  .sel(ctrl[1]), .out(z[7]));
    mux2x1 ins_203 (.in0(y[6]),  .in1(y[8]),  .sel(ctrl[1]), .out(z[6]));
    mux2x1 ins_202 (.in0(y[5]),  .in1(y[7]),  .sel(ctrl[1]), .out(z[5]));
    mux2x1 ins_201 (.in0(y[4]),  .in1(y[6]),  .sel(ctrl[1]), .out(z[4]));
    mux2x1 ins_200 (.in0(y[3]),  .in1(y[5]),  .sel(ctrl[1]), .out(z[3]));
    mux2x1 ins_199 (.in0(y[2]),  .in1(y[4]),  .sel(ctrl[1]), .out(z[2]));
    mux2x1 ins_198 (.in0(y[1]),  .in1(y[3]),  .sel(ctrl[1]), .out(z[1]));
    mux2x1 ins_197 (.in0(y[0]),  .in1(y[2]),  .sel(ctrl[1]), .out(z[0]));

    // 1-bit shift right
    mux2x1 ins_307 (.in0(z[10]), .in1(1'b0),  .sel(ctrl[0]), .out(out[10]));
    mux2x1 ins_306 (.in0(z[9]),  .in1(z[10]), .sel(ctrl[0]), .out(out[9]));
    mux2x1 ins_305 (.in0(z[8]),  .in1(z[9]),  .sel(ctrl[0]), .out(out[8]));
    mux2x1 ins_304 (.in0(z[7]),  .in1(z[8]),  .sel(ctrl[0]), .out(out[7]));
    mux2x1 ins_303 (.in0(z[6]),  .in1(z[7]),  .sel(ctrl[0]), .out(out[6]));
    mux2x1 ins_302 (.in0(z[5]),  .in1(z[6]),  .sel(ctrl[0]), .out(out[5]));
    mux2x1 ins_301 (.in0(z[4]),  .in1(z[5]),  .sel(ctrl[0]), .out(out[4]));
    mux2x1 ins_300 (.in0(z[3]),  .in1(z[4]),  .sel(ctrl[0]), .out(out[3]));
    mux2x1 ins_299 (.in0(z[2]),  .in1(z[3]),  .sel(ctrl[0]), .out(out[2]));
    mux2x1 ins_298 (.in0(z[1]),  .in1(z[2]),  .sel(ctrl[0]), .out(out[1]));
    mux2x1 ins_297 (.in0(z[0]),  .in1(z[1]),  .sel(ctrl[0]), .out(out[0]));

endmodule

// Mux to follow the instantiations from the given Right Barrel Shifter
module mux2x1 (
    input  wire in0,     // First input
    input  wire in1,     // Second input
    input  wire sel,     // Select line
    output wire out      // Output
);
    assign out = sel ? in1 : in0; // Note corrected behavior

endmodule
