// David Denny, 1001915603

// Keypad IU
module InputUnit (
	input [3:0] row, // input row/col
	input clk,
	input clear,
	output [3:0] col,
	output [7:0] out,
	output [7:0] out2,
	output [7:0] out3,
	output [7:0] out4,
	output [15:0] keypadWire);

	// Keypad Scanner and Encoder
	keypad_input Keypad
	(
		.row(row),
		.clk(clk),
		.reset(clear),
		.col(col),
		.out(keypadWire)
	);
	
	// HEX0, all outputs labelled accordingly
	binary2seven Hex0
	(
		.w(keypadWire[3]), // Hex 0
		.x(keypadWire[2]),
		.y(keypadWire[1]),
		.z(keypadWire[0]),
		.a(out[0]), // Hex Outputs
		.b(out[1]),
		.c(out[2]),
		.d(out[3]),
		.e(out[4]),
		.f(out[5]),
		.g(out[6])
	);
	
	// HEX1, all outputs labelled accordingly
	binary2seven Hex1
	(
		.w(keypadWire[7]), // Hex 1
		.x(keypadWire[6]),
		.y(keypadWire[5]),
		.z(keypadWire[4]),
		.a(out2[0]), // Hex Outputs
		.b(out2[1]),
		.c(out2[2]),
		.d(out2[3]),
		.e(out2[4]),
		.f(out2[5]),
		.g(out2[6])
	);
	
	// HEX2, all outputs labelled accordingly
	binary2seven Hex2
	(
		.w(keypadWire[11]), // Hex 2
		.x(keypadWire[10]),
		.y(keypadWire[9]),
		.z(keypadWire[8]),
		.a(out3[0]), // Hex Outputs
		.b(out3[1]),
		.c(out3[2]),
		.d(out3[3]),
		.e(out3[4]),
		.f(out3[5]),
		.g(out3[6])
	);
	
	// HEX3, all outputs labelled accordingly
	binary2seven Hex3
	(
		.w(keypadWire[15]), // Hex 3
		.x(keypadWire[14]),
		.y(keypadWire[13]),
		.z(keypadWire[12]),
		.a(out4[0]), // Hex Outputs
		.b(out4[1]),
		.c(out4[2]),
		.d(out4[3]),
		.e(out4[4]),
		.f(out4[5]),
		.g(out4[6])
	);
	
endmodule